#ifndef _BSTRINGIMPL_CPP
#define _BSTRINGIMPL_CPP

#include <string>
#include <new>

#include "BStringImpl.h"

using namespace std;

BString::BStringImpl::BStringImpl( const char* rhs )
{
   bsLen = cStrLen( rhs );
   bsReserved = ((bsLen+1)/bsIncr+1)*bsIncr;

   try {  bsData = new char[bsReserved];  }
   catch( bad_alloc )
   {  throw BStringXptn( "BStringImpl", BStringXptn::allocFailed );  }
   for ( int k(0); k < bsLen; ++k )  bsData[k] = rhs[k]; 
} // BString::BStringImpl::BStringImpl

BString::BStringImpl::BStringImpl( const BString::BStringImpl& rhs )
{
   bsLen = rhs.bsLen;
   bsReserved = ((bsLen+1)/bsIncr+1)*bsIncr;

   try {  bsData = new char[bsReserved];  }
   catch( bad_alloc )
   {  throw BStringXptn( "BStringImpl", BStringXptn::allocFailed );  }
   for ( int k(0); k < bsLen; ++k )  bsData[k] = rhs.bsData[k]; 
} // BString::BStringImpl::BStringImpl

BString::BStringImpl::~BStringImpl() {  delete bsData;  }

BString::BStringImpl& BString::BStringImpl::operator=( const BString::BStringImpl& rhs )
{
   BString::BStringImpl tmp( rhs );
   if ( &rhs != this )
      swap( tmp );
   return *this;
} // BString::BStringImpl::BStringImpl& operator=

void BString::BStringImpl::swap( BString::BStringImpl& rhs )
{
   size_t sv( bsLen );
   bsLen = rhs.bsLen;  rhs.bsLen = sv; 
   sv = bsReserved;
   bsReserved = rhs.bsReserved;  rhs.bsReserved = sv;

   char* svPtr( bsData );
   bsData = rhs.bsData;  rhs.bsData = svPtr;
} // BString::BStringImpl::swap

size_t BString::BStringImpl::cStrLen( const char cs[] )
{
   const char* p( cs );
   while ( *p != '\0' )  ++p;
   return p-cs;
} // BString::BStringImpl::cStrLen

#endif // _BSTRINGIMPL_CPP
